Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.63
retrieving revision 1.63.2.1
diff -u -r1.63 -r1.63.2.1
--- squid/src/protos.h	26 Sep 2002 21:46:06 -0000	1.63
+++ squid/src/protos.h	3 Oct 2002 01:04:35 -0000	1.63.2.1
@@ -1188,18 +1146,18 @@
 #define strCut(s,pos) (((s).len = pos) , ((s).buf[pos] = '\0'))
 #define strCutPtr(s,ptr) (((s).len = (ptr)-(s).buf) , ((s).buf[(s).len] = '\0'))
 #define strCat(s,str)  stringAppend(&(s), (str), strlen(str))
-extern void stringInit(String * s, const char *str);
-extern void stringLimitInit(String * s, const char *str, int len);
-extern String stringDup(const String * s);
-extern void stringClean(String * s);
-extern void stringReset(String * s, const char *str);
-extern void stringAppend(String * s, const char *buf, int len);
-/* extern void stringAppendf(String *s, const char *fmt, ...) PRINTF_FORMAT_ARG2; */
+SQUIDCEXTERN void stringInit(String * s, const char *str);
+SQUIDCEXTERN void stringLimitInit(String * s, const char *str, int len);
+SQUIDCEXTERN String stringDup(const String * s);
+SQUIDCEXTERN void stringClean(String * s);
+SQUIDCEXTERN void stringReset(String * s, const char *str);
+SQUIDCEXTERN void stringAppend(String * s, const char *buf, int len);
+/* SQUIDCEXTERN void stringAppendf(String *s, const char *fmt, ...) PRINTF_FORMAT_ARG2; */
 
 /*
  * ipc.c
  */
-extern int ipcCreate(int type,
+SQUIDCEXTERN int ipcCreate(int type,
     const char *prog,
     const char *const args[],
     const char *name,
@@ -1207,118 +1165,118 @@
     int *wfd);
 
 /* CacheDigest */
-extern CacheDigest *cacheDigestCreate(int capacity, int bpe);
-extern void cacheDigestDestroy(CacheDigest * cd);
-extern CacheDigest *cacheDigestClone(const CacheDigest * cd);
-extern void cacheDigestClear(CacheDigest * cd);
-extern void cacheDigestChangeCap(CacheDigest * cd, int new_cap);
-extern int cacheDigestTest(const CacheDigest * cd, const cache_key * key);
-extern void cacheDigestAdd(CacheDigest * cd, const cache_key * key);
-extern void cacheDigestDel(CacheDigest * cd, const cache_key * key);
-extern size_t cacheDigestCalcMaskSize(int cap, int bpe);
-extern int cacheDigestBitUtil(const CacheDigest * cd);
-extern void cacheDigestGuessStatsUpdate(cd_guess_stats * stats, int real_hit, int guess_hit);
-extern void cacheDigestGuessStatsReport(const cd_guess_stats * stats, StoreEntry * sentry, const char *label);
-extern void cacheDigestReport(CacheDigest * cd, const char *label, StoreEntry * e);
-
-extern void internalStart(request_t *, StoreEntry *);
-extern int internalCheck(const char *urlpath);
-extern int internalStaticCheck(const char *urlpath);
-extern char *internalLocalUri(const char *dir, const char *name);
-extern char *internalRemoteUri(const char *, u_short, const char *, const char *);
-extern const char *internalHostname(void);
-extern int internalHostnameIs(const char *);
+SQUIDCEXTERN CacheDigest *cacheDigestCreate(int capacity, int bpe);
+SQUIDCEXTERN void cacheDigestDestroy(CacheDigest * cd);
+SQUIDCEXTERN CacheDigest *cacheDigestClone(const CacheDigest * cd);
+SQUIDCEXTERN void cacheDigestClear(CacheDigest * cd);
+SQUIDCEXTERN void cacheDigestChangeCap(CacheDigest * cd, int new_cap);
+SQUIDCEXTERN int cacheDigestTest(const CacheDigest * cd, const cache_key * key);
+SQUIDCEXTERN void cacheDigestAdd(CacheDigest * cd, const cache_key * key);
+SQUIDCEXTERN void cacheDigestDel(CacheDigest * cd, const cache_key * key);
+SQUIDCEXTERN size_t cacheDigestCalcMaskSize(int cap, int bpe);
+SQUIDCEXTERN int cacheDigestBitUtil(const CacheDigest * cd);
+SQUIDCEXTERN void cacheDigestGuessStatsUpdate(cd_guess_stats * stats, int real_hit, int guess_hit);
+SQUIDCEXTERN void cacheDigestGuessStatsReport(const cd_guess_stats * stats, StoreEntry * sentry, const char *label);
+SQUIDCEXTERN void cacheDigestReport(CacheDigest * cd, const char *label, StoreEntry * e);
+
+SQUIDCEXTERN void internalStart(request_t *, StoreEntry *);
+SQUIDCEXTERN int internalCheck(const char *urlpath);
+SQUIDCEXTERN int internalStaticCheck(const char *urlpath);
+SQUIDCEXTERN char *internalLocalUri(const char *dir, const char *name);
+SQUIDCEXTERN char *internalRemoteUri(const char *, u_short, const char *, const char *);
+SQUIDCEXTERN const char *internalHostname(void);
+SQUIDCEXTERN int internalHostnameIs(const char *);
 
 #if USE_CARP
-extern void carpInit(void);
-extern peer *carpSelectParent(request_t *);
+SQUIDCEXTERN void carpInit(void);
+SQUIDCEXTERN peer *carpSelectParent(request_t *);
 #endif
 
 #if DELAY_POOLS
-extern void delayPoolsInit(void);
-extern void delayInitDelayData(unsigned short pools);
-extern void delayFreeDelayData(unsigned short pools);
-extern void delayCreateDelayPool(unsigned short pool, u_char class);
-extern void delayInitDelayPool(unsigned short pool, u_char class, delaySpecSet * rates);
-extern void delayFreeDelayPool(unsigned short pool);
-extern void delayPoolsReconfigure(void);
-extern void delaySetNoDelay(int fd);
-extern void delayClearNoDelay(int fd);
-extern int delayIsNoDelay(int fd);
-extern delay_id delayClient(clientHttpRequest *);
-extern EVH delayPoolsUpdate;
-extern int delayBytesWanted(delay_id d, int min, int max);
-extern void delayBytesIn(delay_id, int qty);
-extern int delayMostBytesWanted(const MemObject * mem, int max);
-extern delay_id delayMostBytesAllowed(const MemObject * mem);
-extern void delaySetStoreClient(store_client * sc, delay_id delay_id);
-extern void delayRegisterDelayIdPtr(delay_id * loc);
-extern void delayUnregisterDelayIdPtr(delay_id * loc);
+SQUIDCEXTERN void delayPoolsInit(void);
+SQUIDCEXTERN void delayInitDelayData(unsigned short pools);
+SQUIDCEXTERN void delayFreeDelayData(unsigned short pools);
+SQUIDCEXTERN void delayCreateDelayPool(unsigned short pool, u_char class);
+SQUIDCEXTERN void delayInitDelayPool(unsigned short pool, u_char class, delaySpecSet * rates);
+SQUIDCEXTERN void delayFreeDelayPool(unsigned short pool);
+SQUIDCEXTERN void delayPoolsReconfigure(void);
+SQUIDCEXTERN void delaySetNoDelay(int fd);
+SQUIDCEXTERN void delayClearNoDelay(int fd);
+SQUIDCEXTERN int delayIsNoDelay(int fd);
+SQUIDCEXTERN delay_id delayClient(clientHttpRequest *);
+SQUIDCEXTERN EVH delayPoolsUpdate;
+SQUIDCEXTERN int delayBytesWanted(delay_id d, int min, int max);
+SQUIDCEXTERN void delayBytesIn(delay_id, int qty);
+SQUIDCEXTERN int delayMostBytesWanted(const MemObject * mem, int max);
+SQUIDCEXTERN delay_id delayMostBytesAllowed(const MemObject * mem);
+SQUIDCEXTERN void delaySetStoreClient(store_client * sc, delay_id delay_id);
+SQUIDCEXTERN void delayRegisterDelayIdPtr(delay_id * loc);
+SQUIDCEXTERN void delayUnregisterDelayIdPtr(delay_id * loc);
 #endif
 
 /* helper.c */
-extern void helperOpenServers(helper * hlp);
-extern void helperStatefulOpenServers(statefulhelper * hlp);
-extern void helperSubmit(helper * hlp, const char *buf, HLPCB * callback, void *data);
-extern void helperStatefulSubmit(statefulhelper * hlp, const char *buf, HLPSCB * callback, void *data, helper_stateful_server * lastserver);
-extern void helperStats(StoreEntry * sentry, helper * hlp);
-extern void helperStatefulStats(StoreEntry * sentry, statefulhelper * hlp);
-extern void helperShutdown(helper * hlp);
-extern void helperStatefulShutdown(statefulhelper * hlp);
-extern helper *helperCreate(const char *);
-extern statefulhelper *helperStatefulCreate(const char *);
-extern void helperFree(helper *);
-extern void helperStatefulFree(statefulhelper *);
-extern void helperStatefulReset(helper_stateful_server * srv);
-extern void helperStatefulReleaseServer(helper_stateful_server * srv);
-extern void *helperStatefulServerGetData(helper_stateful_server * srv);
-extern helper_stateful_server *helperStatefulDefer(statefulhelper *);
+SQUIDCEXTERN void helperOpenServers(helper * hlp);
+SQUIDCEXTERN void helperStatefulOpenServers(statefulhelper * hlp);
+SQUIDCEXTERN void helperSubmit(helper * hlp, const char *buf, HLPCB * callback, void *data);
+SQUIDCEXTERN void helperStatefulSubmit(statefulhelper * hlp, const char *buf, HLPSCB * callback, void *data, helper_stateful_server * lastserver);
+SQUIDCEXTERN void helperStats(StoreEntry * sentry, helper * hlp);
+SQUIDCEXTERN void helperStatefulStats(StoreEntry * sentry, statefulhelper * hlp);
+SQUIDCEXTERN void helperShutdown(helper * hlp);
+SQUIDCEXTERN void helperStatefulShutdown(statefulhelper * hlp);
+SQUIDCEXTERN helper *helperCreate(const char *);
+SQUIDCEXTERN statefulhelper *helperStatefulCreate(const char *);
+SQUIDCEXTERN void helperFree(helper *);
+SQUIDCEXTERN void helperStatefulFree(statefulhelper *);
+SQUIDCEXTERN void helperStatefulReset(helper_stateful_server * srv);
+SQUIDCEXTERN void helperStatefulReleaseServer(helper_stateful_server * srv);
+SQUIDCEXTERN void *helperStatefulServerGetData(helper_stateful_server * srv);
+SQUIDCEXTERN helper_stateful_server *helperStatefulDefer(statefulhelper *);
 
 
 
 #if USE_LEAKFINDER
-extern void leakInit(void);
-extern void *leakAddFL(void *, const char *, int);
-extern void *leakTouchFL(void *, const char *, int);
-extern void *leakFreeFL(void *, const char *, int);
+SQUIDCEXTERN void leakInit(void);
+SQUIDCEXTERN void *leakAddFL(void *, const char *, int);
+SQUIDCEXTERN void *leakTouchFL(void *, const char *, int);
+SQUIDCEXTERN void *leakFreeFL(void *, const char *, int);
 #endif
 
 /* logfile.c */
-extern Logfile *logfileOpen(const char *path, size_t bufsz, int);
-extern void logfileClose(Logfile * lf);
-extern void logfileRotate(Logfile * lf);
-extern void logfileWrite(Logfile * lf, void *buf, size_t len);
-extern void logfileFlush(Logfile * lf);
+SQUIDCEXTERN Logfile *logfileOpen(const char *path, size_t bufsz, int);
+SQUIDCEXTERN void logfileClose(Logfile * lf);
+SQUIDCEXTERN void logfileRotate(Logfile * lf);
+SQUIDCEXTERN void logfileWrite(Logfile * lf, void *buf, size_t len);
+SQUIDCEXTERN void logfileFlush(Logfile * lf);
 #if STDC_HEADERS
-extern void
+SQUIDCEXTERN void
 logfilePrintf(Logfile * lf, const char *fmt,...) PRINTF_FORMAT_ARG2;
 #else
-extern void logfilePrintf(va_alist);
+SQUIDCEXTERN void logfilePrintf(va_alist);
 #endif
 
 /*
  * Removal Policies
  */
-extern RemovalPolicy *createRemovalPolicy(RemovalPolicySettings * settings);
+SQUIDCEXTERN RemovalPolicy *createRemovalPolicy(RemovalPolicySettings * settings);
 
 /*
  * prototypes for system functions missing from system includes
  */
 
 #ifdef _SQUID_SOLARIS_
-extern int getrusage(int, struct rusage *);
-extern int getpagesize(void);
-extern int gethostname(char *, int);
+SQUIDCEXTERN int getrusage(int, struct rusage *);
+SQUIDCEXTERN int getpagesize(void);
+SQUIDCEXTERN int gethostname(char *, int);
 #endif
 
 #if URL_CHECKSUM_DEBUG
-extern unsigned int url_checksum(const char *url);
+SQUIDCEXTERN unsigned int url_checksum(const char *url);
 #endif
 
 /*
  * hack to allow snmp access to the statistics counters
  */
-extern StatCounters *snmpStatGet(int);
+SQUIDCEXTERN StatCounters *snmpStatGet(int);
 
 /* Vary support functions */
 int varyEvaluateMatch(StoreEntry * entry, request_t * req);
@@ -1326,22 +1284,22 @@
 /* CygWin & Windows NT Port */
 /* win32.c */
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
-extern int WIN32_Subsystem_Init(void);
-extern void WIN32_Exit(void);
+SQUIDCEXTERN int WIN32_Subsystem_Init(void);
+SQUIDCEXTERN void WIN32_Exit(void);
 #endif
 
 /* external_acl.c */
-extern void parse_externalAclHelper(external_acl **);
-extern void dump_externalAclHelper(StoreEntry * sentry, const char *name, const external_acl *);
-extern void free_externalAclHelper(external_acl **);
-extern void aclParseExternal(void *curlist);
-extern void aclDestroyExternal(void **curlust);
-extern int aclMatchExternal(void *dataptr, aclCheck_t * ch);
-extern wordlist *aclDumpExternal(void *dataptr);
+SQUIDCEXTERN void parse_externalAclHelper(external_acl **);
+SQUIDCEXTERN void dump_externalAclHelper(StoreEntry * sentry, const char *name, const external_acl *);
+SQUIDCEXTERN void free_externalAclHelper(external_acl **);
+SQUIDCEXTERN void aclParseExternal(void *curlist);
+SQUIDCEXTERN void aclDestroyExternal(void **curlust);
+SQUIDCEXTERN int aclMatchExternal(void *dataptr, aclCheck_t * ch);
+SQUIDCEXTERN wordlist *aclDumpExternal(void *dataptr);
 typedef void EAH(void *data, void *result);
-extern void externalAclLookup(aclCheck_t * ch, void *acl_data, EAH * handler, void *data);
-extern void externalAclInit(void);
-extern void externalAclShutdown(void);
-extern char *strtokFile(void);
+SQUIDCEXTERN void externalAclLookup(aclCheck_t * ch, void *acl_data, EAH * handler, void *data);
+SQUIDCEXTERN void externalAclInit(void);
+SQUIDCEXTERN void externalAclShutdown(void);
+SQUIDCEXTERN char *strtokFile(void);
 
 #endif /* SQUID_PROTOS_H */
--- /dev/null	Wed Feb 14 01:05:20 2007
+++ squid/src/redirect.cc	Wed Feb 14 01:07:15 2007
@@ -0,0 +1,180 @@
+
+/*
+ * $Id: redirect.cc,v 1.1.2.1 2002/10/03 01:04:36 rbcollins Exp $
+ *
+ * DEBUG: section 61    Redirector
+ * AUTHOR: Duane Wessels
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+#include "authenticate.h"
+
+typedef struct {
+    void *data;
+    char *orig_url;
+    struct in_addr client_addr;
+    const char *client_ident;
+    const char *method_s;
+    RH *handler;
+} redirectStateData;
+
+static HLPCB redirectHandleReply;
+static void redirectStateFree(redirectStateData * r);
+static helper *redirectors = NULL;
+static OBJH redirectStats;
+static int n_bypassed = 0;
+CBDATA_TYPE(redirectStateData);
+
+static void
+redirectHandleReply(void *data, char *reply)
+{
+    redirectStateData *r = static_cast<redirectStateData *>(data);
+    char *t;
+    void *cbdata;
+    debug(61, 5) ("redirectHandleRead: {%s}\n", reply ? reply : "<NULL>");
+    if (reply) {
+	if ((t = strchr(reply, ' ')))
+	    *t = '\0';
+	if (*reply == '\0')
+	    reply = NULL;
+    }
+    if (cbdataReferenceValidDone(r->data, &cbdata))
+	r->handler(cbdata, reply);
+    redirectStateFree(r);
+}
+
+static void
+redirectStateFree(redirectStateData * r)
+{
+    safe_free(r->orig_url);
+    cbdataFree(r);
+}
+
+static void
+redirectStats(StoreEntry * sentry)
+{
+    storeAppendPrintf(sentry, "Redirector Statistics:\n");
+    helperStats(sentry, redirectors);
+    if (Config.onoff.redirector_bypass)
+	storeAppendPrintf(sentry, "\nNumber of requests bypassed "
+	    "because all redirectors were busy: %d\n", n_bypassed);
+}
+
+/**** PUBLIC FUNCTIONS ****/
+
+void
+redirectStart(clientHttpRequest * http, RH * handler, void *data)
+{
+    ConnStateData *conn = http->conn;
+    redirectStateData *r = NULL;
+    const char *fqdn;
+    char buf[8192];
+    assert(http);
+    assert(handler);
+    debug(61, 5) ("redirectStart: '%s'\n", http->uri);
+    if (Config.Program.redirect == NULL) {
+	handler(data, NULL);
+	return;
+    }
+    if (Config.accessList.redirector) {
+	aclCheck_t ch;
+	memset(&ch, '\0', sizeof(ch));
+	ch.src_addr = http->conn->peer.sin_addr;
+	ch.my_addr = http->conn->me.sin_addr;
+	ch.my_port = ntohs(http->conn->me.sin_port);
+	ch.request = http->request;
+	if (!aclCheckFast(Config.accessList.redirector, &ch)) {
+	    /* denied -- bypass redirector */
+	    handler(data, NULL);
+	    return;
+	}
+    }
+    if (Config.onoff.redirector_bypass && redirectors->stats.queue_size) {
+	/* Skip redirector if there is one request queued */
+	n_bypassed++;
+	handler(data, NULL);
+	return;
+    }
+    r = cbdataAlloc(redirectStateData);
+    r->orig_url = xstrdup(http->uri);
+    r->client_addr = conn->log_addr;
+    if (http->request->auth_user_request)
+	r->client_ident = authenticateUserRequestUsername(http->request->auth_user_request);
+    else if (conn->rfc931[0]) {
+	r->client_ident = conn->rfc931;
+    } else {
+	r->client_ident = dash_str;
+    }
+    r->method_s = RequestMethodStr[http->request->method];
+    r->handler = handler;
+    r->data = cbdataReference(data);
+    if ((fqdn = fqdncache_gethostbyaddr(r->client_addr, 0)) == NULL)
+	fqdn = dash_str;
+    snprintf(buf, 8192, "%s %s/%s %s %s\n",
+	r->orig_url,
+	inet_ntoa(r->client_addr),
+	fqdn,
+	r->client_ident,
+	r->method_s);
+    helperSubmit(redirectors, buf, redirectHandleReply, r);
+}
+
+void
+redirectInit(void)
+{
+    static int init = 0;
+    if (!Config.Program.redirect)
+	return;
+    if (redirectors == NULL)
+	redirectors = helperCreate("redirector");
+    redirectors->cmdline = Config.Program.redirect;
+    redirectors->n_to_start = Config.redirectChildren;
+    redirectors->ipc_type = IPC_STREAM;
+    helperOpenServers(redirectors);
+    if (!init) {
+	cachemgrRegister("redirector",
+	    "URL Redirector Stats",
+	    redirectStats, 0, 1);
+	init = 1;
+	CBDATA_INIT_TYPE(redirectStateData);
+    }
+}
+
+void
+redirectShutdown(void)
+{
+    if (!redirectors)
+	return;
+    helperShutdown(redirectors);
+    if (!shutting_down)
+	return;
+    helperFree(redirectors);
+    redirectors = NULL;
+}
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.70
retrieving revision 1.70.2.1
diff -u -r1.70 -r1.70.2.1
--- squid/src/structs.h	26 Sep 2002 21:46:06 -0000	1.70
+++ squid/src/structs.h	3 Oct 2002 01:04:36 -0000	1.70.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.70 2002/09/26 21:46:06 squidadm Exp $
+ * $Id: structs.h,v 1.70.2.1 2002/10/03 01:04:36 rbcollins Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -88,107 +88,6 @@
     void *acl_data;
 };
 
-struct _auth_user_hash_pointer {
-    /* first two items must be same as hash_link */
-    char *key;
-    auth_user_hash_pointer *next;
-    auth_user_t *auth_user;
-    dlink_node link;		/* other hash entries that point to the same auth_user */
-};
-
-struct _auth_user_ip_t {
-    dlink_node node;
-    /* IP addr this user authenticated from */
-    struct in_addr ipaddr;
-    time_t ip_expiretime;
-};
-
-struct _auth_user_t {
-    /* extra fields for proxy_auth */
-    /* this determines what scheme owns the user data. */
-    auth_type_t auth_type;
-    /* the index +1 in the authscheme_list to the authscheme entry */
-    int auth_module;
-    /* we only have one username associated with a given auth_user struct */
-    auth_user_hash_pointer *usernamehash;
-    /* we may have many proxy-authenticate strings that decode to the same user */
-    dlink_list proxy_auth_list;
-    dlink_list proxy_match_cache;
-    /* what ip addresses has this user been seen at?, plus a list length cache */
-    dlink_list ip_list;
-    size_t ipcount;
-    long expiretime;
-    /* how many references are outstanding to this instance */
-    size_t references;
-    /* the auth scheme has it's own private data area */
-    void *scheme_data;
-    /* the auth_user_request structures that link to this. Yes it could be a splaytree
-     * but how many requests will a single username have in parallel? */
-    dlink_list requests;
-};
-
-struct _auth_user_request_t {
-    /* this is the object passed around by client_side and acl functions */
-    /* it has request specific data, and links to user specific data */
-    /* the user */
-    auth_user_t *auth_user;
-    /* return a message on the 407 error pages */
-    char *message;
-    /* any scheme specific request related data */
-    void *scheme_data;
-    /* how many 'processes' are working on this data */
-    size_t references;
-    /* We only attempt authentication once per http request. This 
-     * is to allow multiple auth acl references from different _access areas
-     * when using connection based authentication
-     */
-    auth_acl_t lastReply;
-};
-
-
-/*
- * This defines an auth scheme module
- */
-
-struct _authscheme_entry {
-    const char *typestr;
-    AUTHSACTIVE *Active;
-    AUTHSADDHEADER *AddHeader;
-    AUTHSADDTRAILER *AddTrailer;
-    AUTHSAUTHED *authenticated;
-    AUTHSAUTHUSER *authAuthenticate;
-    AUTHSCONFIGURED *configured;
-    AUTHSDUMP *dump;
-    AUTHSFIXERR *authFixHeader;
-    AUTHSFREE *FreeUser;
-    AUTHSFREECONFIG *freeconfig;
-    AUTHSUSERNAME *authUserUsername;
-    AUTHSONCLOSEC *oncloseconnection;	/*optional */
-    AUTHSCONNLASTHEADER *authConnLastHeader;
-    AUTHSDECODE *decodeauth;
-    AUTHSDIRECTION *getdirection;
-    AUTHSPARSE *parse;
-    AUTHSINIT *init;
-    AUTHSREQFREE *requestFree;
-    AUTHSSHUTDOWN *donefunc;
-    AUTHSSTART *authStart;
-    AUTHSSTATS *authStats;
-};
-
-/*
- * This is a configured auth scheme
- */
-
-/* private data types */
-struct _authScheme {
-    /* pointer to the authscheme_list's string entry */
-    const char *typestr;
-    /* the scheme id in the authscheme_list */
-    int Id;
-    /* the scheme's configuration details. */
-    void *scheme_data;
-};
-
 struct _acl_deny_info_list {
     int err_page_id;
     char *err_page_name;
@@ -368,6 +267,12 @@
 
 #endif
 
+struct _authConfig {
+    authScheme *schemes;
+    int n_allocated;
+    int n_configured;
+};
+
 struct _RemovalPolicySettings {
     char *type;
     wordlist *args;
@@ -619,11 +524,7 @@
 	acl_tos *outgoing_tos;
     } accessList;
     acl_deny_info_list *denyInfoList;
-    struct _authConfig {
-	authScheme *schemes;
-	int n_allocated;
-	int n_configured;
-    } authConfig;
+    authConfig authConfiguration;
     struct {
 	size_t list_width;
 	int list_wrap;
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.29
retrieving revision 1.29.2.1
diff -u -r1.29 -r1.29.2.1
--- squid/src/typedefs.h	24 Sep 2002 10:59:17 -0000	1.29
+++ squid/src/typedefs.h	3 Oct 2002 01:04:36 -0000	1.29.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.29 2002/09/24 10:59:17 rbcollins Exp $
+ * $Id: typedefs.h,v 1.29.2.1 2002/10/03 01:04:36 rbcollins Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -55,10 +55,10 @@
 typedef struct _acl_time_data acl_time_data;
 typedef struct _acl_name_list acl_name_list;
 typedef struct _acl_deny_info_list acl_deny_info_list;
-typedef struct _auth_user_t auth_user_t;
-typedef struct _auth_user_request_t auth_user_request_t;
-typedef struct _auth_user_hash_pointer auth_user_hash_pointer;
-typedef struct _auth_user_ip_t auth_user_ip_t;
+typedef struct AuthUser auth_user_t;
+typedef struct AuthUserRequest auth_user_request_t;
+typedef struct AuthUserHashPointer auth_user_hash_pointer;
+typedef struct AuthUserIP auth_user_ip_t;
 typedef struct _acl_proxy_auth_match_cache acl_proxy_auth_match_cache;
 typedef struct _authscheme_entry authscheme_entry_t;
 typedef struct _authScheme authScheme;
@@ -286,30 +286,6 @@
 typedef double hbase_f(double);
 typedef void StatHistBinDumper(StoreEntry *, int idx, double val, double size, int count);
 
-/* authenticate.c authenticate scheme routines typedefs */
-typedef int AUTHSACTIVE(void);
-typedef int AUTHSAUTHED(auth_user_request_t *);
-typedef void AUTHSAUTHUSER(auth_user_request_t *, request_t *, ConnStateData *, http_hdr_type);
-typedef int AUTHSCONFIGURED(void);
-typedef void AUTHSDECODE(auth_user_request_t *, const char *);
-typedef int AUTHSDIRECTION(auth_user_request_t *);
-typedef void AUTHSDUMP(StoreEntry *, const char *, authScheme *);
-typedef void AUTHSFIXERR(auth_user_request_t *, HttpReply *, http_hdr_type, request_t *);
-typedef void AUTHSADDHEADER(auth_user_request_t *, HttpReply *, int);
-typedef void AUTHSADDTRAILER(auth_user_request_t *, HttpReply *, int);
-typedef void AUTHSFREE(auth_user_t *);
-typedef void AUTHSFREECONFIG(authScheme *);
-typedef char *AUTHSUSERNAME(auth_user_t *);
-typedef void AUTHSONCLOSEC(ConnStateData *);
-typedef void AUTHSPARSE(authScheme *, int, char *);
-typedef void AUTHSINIT(authScheme *);
-typedef void AUTHSREQFREE(auth_user_request_t *);
-typedef void AUTHSSETUP(authscheme_entry_t *);
-typedef void AUTHSSHUTDOWN(void);
-typedef void AUTHSSTART(auth_user_request_t *, RH *, void *);
-typedef void AUTHSSTATS(StoreEntry *);
-typedef const char *AUTHSCONNLASTHEADER(auth_user_request_t *);
-
 /* append/vprintf's for Packer */
 typedef void (*append_f) (void *, const char *buf, int size);
 #if STDC_HEADERS
Index: squid/src/auth/Makefile.am
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/auth/Makefile.am,v
retrieving revision 1.2
retrieving revision 1.2.72.1
diff -u -r1.2 -r1.2.72.1
--- squid/src/auth/Makefile.am	1 Sep 2001 11:46:49 -0000	1.2
+++ squid/src/auth/Makefile.am	3 Oct 2002 01:04:36 -0000	1.2.72.1
@@ -4,15 +4,15 @@
 #
 AUTOMAKE_OPTIONS = subdir-objects
 
-DIST_SUBDIRS	= basic digest ntlm
-SUBDIRS		= @AUTH_MODULES@
+##DIST_SUBDIRS	= basic digest ntlm
+##SUBDIRS		= @AUTH_MODULES@
 
 EXTRA_LIBRARIES	= libbasic.a libdigest.a libntlm.a
 noinst_LIBRARIES	= @AUTH_LIBS@
 
-libbasic_a_SOURCES	= basic/auth_basic.c basic/auth_basic.h
-libdigest_a_SOURCES	= digest/auth_digest.c digest/auth_digest.h
-libntlm_a_SOURCES	= ntlm/auth_ntlm.c ntlm/auth_ntlm.h
+libbasic_a_SOURCES	= basic/auth_basic.cc basic/auth_basic.h
+libdigest_a_SOURCES	= digest/auth_digest.cc digest/auth_digest.h
+libntlm_a_SOURCES	= ntlm/auth_ntlm.cc ntlm/auth_ntlm.h
 
 INCLUDES      = -I. -I$(top_builddir)/include -I$(top_srcdir)/include \
 	-I$(top_srcdir)/src/
